#include <amxmodx>
#include <aes_v>
#include <fakemeta>
#include <reapi>

#define MYSQL_SUPPORT	// Раскомментируйте данный define ,если хотите сохранять в БД MYSQL(по умолчанию, сохранение через nvault)

#if defined MYSQL_SUPPORT
#include <sqlx>
#else
#include <nvault>
#endif

enum _:eCvars
{
	Float: ENT_LIFETIME,
	GLOW,
	AES_DEAD,
	AES_ALL,
	AES_EXP,
	TIME_DELETE,
	AES_BONUS
}

new g_eCvar[eCvars];

new g_iMaxPlayers;
new g_iCoin[MAX_PLAYERS + 1];

new const ENT_CLASSNAME[] = "raise_the_coin";
new const ENT_MODEL[] = "models/exp.mdl";
//new const SND_PICKUP[] = "exp.wav";

// НАСТРОЙКА ДАННЫХ MYSQL (Вводить, если раскомментировон #define MYSQL_SUPPORT)
#if defined MYSQL_SUPPORT
new const Host[]	= "127.0.0.1";		// ip адрес хоста
new const User[]	= "user";			// Имя хоста
new const Pass[]	= "pass";			// Пароль хоста
new const Db[]		= "sentry_cs_coin";	// Название бд
// КОНЕЦ НАСТРОЙКИ ДАННЫХ MYSQL

new Handle:sql_typle;
#else
new g_Vault;
#endif

public plugin_init( )
{
	register_plugin( "(AES)Raise_the_coin", "1.0.0", "Baton4ik48" );
	RegisterHookChain(RG_CBasePlayer_Killed, "CBasePlayer_Killed_Post", true);
	g_iMaxPlayers = get_maxplayers();
	set_task(2.0, "Task_HudMsg", .flags = "b");
}

// Настройка кваров
public plugin_cfg()
{
	bind_pcvar_float(create_cvar("raise_ent_life", "7.0", FCVAR_NONE), g_eCvar[ENT_LIFETIME]); // Время через которое исчезнет монета
	bind_pcvar_num(create_cvar("raise_ent_glow", "1", FCVAR_NONE), g_eCvar[GLOW]); // Свечение монеты
	bind_pcvar_num(create_cvar("raise_dead_exp", "1", FCVAR_NONE), g_eCvar[AES_DEAD]); // Кол-во опыта теряемое при смерти (ставить без минуса)
	bind_pcvar_num(create_cvar("raise_aes_all", "30", FCVAR_NONE), g_eCvar[AES_ALL]); // Необходимое кол-во монет до вознаграждения
	bind_pcvar_num(create_cvar("raise_aes_exp", "100", FCVAR_NONE), g_eCvar[AES_EXP]); // Кол-во опыта за вознаграждении
	bind_pcvar_num(create_cvar("raise_aes_bonus", "10", FCVAR_NONE), g_eCvar[AES_BONUS]); // Кол-во бонусов за вознаграждении
	bind_pcvar_num(create_cvar("raise_deletetime", "5", FCVAR_NONE), g_eCvar[TIME_DELETE]); // Записи игроков, не заходивших указанное кол-во дней, удаляются из хранилища. Меньше 1, - отключить (не рекомендуется) Квар для nvault!!!

// Конец настройки кваров

#if defined MYSQL_SUPPORT
	set_task(1.0, "mysql_start");
#else
	g_Vault = nvault_open("raise_the_coin");
	if(g_Vault == INVALID_HANDLE)
	{
		set_fail_state("Error nvault");
	}
	if(g_eCvar[TIME_DELETE] > 0)
	{
		nvault_prune(g_Vault, 0, get_systime() - (86400 * g_eCvar[TIME_DELETE]));
	}
#endif
}


public plugin_precache()
{
	precache_model(ENT_MODEL);
	//precache_sound(SND_PICKUP);
}


public CBasePlayer_Killed_Post(pVictim, pAttacker, pGib)
{
	new Float: vecOrigin[3];
	new Float: vecVelocity[3];

	get_entvar(pVictim, var_origin, vecOrigin);

	new iEntity = rg_create_entity("info_target", false);

	if(is_nullent(iEntity))
	{
		return;
	}

	aes_add_player_exp_f(pVictim, -g_eCvar[AES_DEAD]);

	vecVelocity[0] = random_float(-200.0, 200.0);
	vecVelocity[1] = random_float(-200.0, 200.0);
	vecVelocity[2] = random_float(1.0, 200.0);

	engfunc(EngFunc_SetModel, iEntity, ENT_MODEL);
	engfunc(EngFunc_SetSize, iEntity, {-9.0, -7.0, -0.0}, {9.0, 7.0, 6.0});
	set_entvar(iEntity, var_framerate, 1.0);
	set_entvar(iEntity, var_sequence, 2);
	engfunc(EngFunc_AnimationAutomove, iEntity, 100.0);

	set_entvar(iEntity, var_origin, vecOrigin);
	set_entvar(iEntity, var_classname, ENT_CLASSNAME);
	set_entvar(iEntity, var_movetype, MOVETYPE_TOSS);
	set_entvar(iEntity, var_solid, SOLID_TRIGGER);
	set_entvar(iEntity, var_velocity, vecVelocity);
	set_entvar(iEntity, var_nextthink, get_gametime() + g_eCvar[ENT_LIFETIME]);

	if(g_eCvar[GLOW])
	{
		set_entvar(iEntity, var_rendermode, kRenderGlow);
		set_entvar(iEntity, var_renderamt, 1.0);
		set_entvar(iEntity, var_rendercolor, Float: { 0.0, 255.0, 0.0 });
		set_entvar(iEntity, var_renderfx, kRenderFxGlowShell);
	}

	SetThink(iEntity, "Cashbrick_Think");
	SetTouch(iEntity, "Cashbrick_Touch");
}

public Cashbrick_Think(pEntity)
{
	if(!is_entity(pEntity))
	{
		return;
	}

	if(get_entvar(pEntity, var_iuser2))
	{
		new Float: fRenderAmt;
		get_entvar(pEntity, var_renderamt, fRenderAmt);

		if(fRenderAmt > 20.0)
		{
			set_entvar(pEntity, var_renderamt, fRenderAmt - 20.0);
			set_entvar(pEntity, var_nextthink, get_gametime() + 0.1);
		}
		else
		{
			set_entvar(pEntity, var_flags, FL_KILLME);
		}
	}
	else
	{
		set_entvar(pEntity, var_iuser2, 1);
		set_entvar(pEntity, var_rendermode, kRenderTransTexture);
		set_entvar(pEntity, var_renderamt, 255.0);
		set_entvar(pEntity, var_nextthink, get_gametime() + 1.5);
	}
}

public Cashbrick_Touch(pEntity, pToucher)
{
	if(!is_entity(pEntity) || !is_user_connected(pToucher))
	{
		return;
	}

	g_iCoin[pToucher]++;
	set_hudmessage(0, 255, 0, -1.0, 0.26, 0, 0.1, 2.0, 0.1, 0.1, 3);
	show_hudmessage(pToucher, "+1 монета", g_iCoin);
	//rh_emit_sound2(pToucher, 0, CHAN_ITEM, SND_PICKUP, VOL_NORM, ATTN_NORM);
	set_entvar(pEntity, var_flags, FL_KILLME);

	if(g_iCoin[pToucher] == g_eCvar[AES_ALL])
	{
		client_print_color(pToucher, print_team_default, "^1Вы получили ^4%i ^1опыта и ^4%i ^1бонус.", g_eCvar[AES_EXP] ,g_eCvar[AES_BONUS]);
		aes_add_player_exp_f(pToucher, g_eCvar[AES_EXP]);
		aes_add_player_bonus_f(pToucher, g_eCvar[AES_BONUS]);
		g_iCoin[pToucher] = 0;
	}
}

public Task_HudMsg()
{
	set_hudmessage(200, 200, 200, 0.01, 0.90, 0, 0.1, 1.0, 0.1, 0.1, 4);

	for(new id = 1; id < g_iMaxPlayers; id++)
	{
		if(!is_user_alive(id))
		{
			continue;
		}

		show_hudmessage(id, "Монет до вознаграждение: %i/%i", g_iCoin[id], g_eCvar[AES_ALL]);
	}
}

public client_putinserver(id)
{
#if defined MYSQL_SUPPORT
	Load_MySql(id);
#else
	load_coins(id);
#endif
}

public client_disconnected(id)
{
#if defined MYSQL_SUPPORT
	Save_MySql(id);
#else
	save_coins(id);
#endif
}

public plugin_end()
{
#if defined MYSQL_SUPPORT
	if(sql_typle)
	{
		SQL_FreeHandle(sql_typle);
		log_amx("sql_close");
	}
#else
	nvault_close(g_Vault);
	log_amx("nvault_close");
#endif
}

#if defined MYSQL_SUPPORT
public mysql_start()
{
	SQL_SetAffinity("mysql");
	sql_typle = SQL_MakeDbTuple(Host, User, Pass, Db);

	SQL_SetCharset(sql_typle, "utf8");

	new szQuery[MAX_FMT_LENGTH];
	
	formatex(szQuery, charsmax(szQuery),
	"CREATE TABLE IF NOT EXISTS `Raise_the_coin` (\
	`id` int(11) NOT NULL AUTO_INCREMENT,\
	`steamid` varchar(64) NOT NULL UNIQUE,\
	`coin` int(11) DEFAULT 0,\
	PRIMARY KEY (`id`)\
	)ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;");

	SQL_ThreadQuery(sql_typle, "func_QueryHandler", szQuery);
}

public func_QueryHandler(iFailState, Handle:Query, szError[], iErrNum, data[], size, Float:flQueryTime) 
{
	if(iFailState != TQUERY_SUCCESS)
	{
		log_amx("MySQL Error: %d (%s)", iErrNum, szError);
	}
}

public Load_MySql(id)
{
	new szQuery[MAX_FMT_LENGTH], szAuthID[MAX_AUTHID_LENGTH], iData[2];
	get_user_authid(id, szAuthID, charsmax(szAuthID));

	iData[0] = id;

	formatex(szQuery, charsmax(szQuery), "SELECT * FROM `Raise_the_coin` WHERE `steamid` = '%s'", szAuthID);
	SQL_ThreadQuery(sql_typle, "registration_client", szQuery, iData, charsmax(iData));
}

public registration_client(FailState, Handle:Query, Error[], Errcode, Data[], DataSize)
{
	if(FailState == TQUERY_CONNECT_FAILED)
	{
		log_amx("Load - Could not connect to SQL database. [%d] %s", Errcode, Error);
	}
	else if(FailState == TQUERY_QUERY_FAILED)
	{
		log_amx("Load Query failed. [%d] %s", Errcode, Error);
	}

	new id = Data[0];

	if(SQL_NumResults(Query) < 1)
	{
		new szQuery[MAX_FMT_LENGTH], szAuthID[MAX_AUTHID_LENGTH];

		get_user_authid(id, szAuthID, charsmax(szAuthID));

		formatex(szQuery, charsmax(szQuery), "INSERT INTO `Raise_the_coin` (steamid, coin) VALUES ('%s', '0')", szAuthID);
		SQL_ThreadQuery(sql_typle, "ignore_handle", szQuery);
	}
	else
	{
		g_iCoin[id] = SQL_ReadResult(Query, SQL_FieldNameToNum(Query, "coin"));
	}
	return PLUGIN_HANDLED;
}

public Save_MySql(id)
{
	new szQuery[MAX_FMT_LENGTH], szAuthID[MAX_AUTHID_LENGTH];
	get_user_authid(id, szAuthID, charsmax(szAuthID));

	formatex(szQuery, charsmax(szQuery), "UPDATE `Raise_the_coin` SET `coin` = '%i' WHERE `id` = '%d'", g_iCoin[id], szAuthID);
	SQL_ThreadQuery(sql_typle, "ignore_handle", szQuery);
}

public ignore_handle(FailState, Handle:Query, Error[], Errcode, Data[], DataSize)
{
	SQL_FreeHandle(Query);
	return PLUGIN_HANDLED;
}
#else
save_coins(id)
{
	new szAuthID[MAX_AUTHID_LENGTH], szCoin[15];

	get_user_authid(id, szAuthID, charsmax(szAuthID));

	formatex(szCoin, charsmax(szCoin), "%i", g_iCoin[id]);
	nvault_set(g_Vault, szAuthID, szCoin);
}

load_coins(id)
{
	new szAuthID[MAX_AUTHID_LENGTH], szCoin[15];

	get_user_authid(id, szAuthID, charsmax(szAuthID));

	nvault_get(g_Vault, szAuthID, szCoin, charsmax(szCoin));
	g_iCoin[id] = str_to_num(szCoin);
}
#endif